<!DOCTYPE html>
<html>

<head>
  <meta charset='utf-8'>
  <title>Pizza 365 project</title>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onclick="onPageLoading()">
  <div class="container">
    <p class="h3 text-center mt-5"> Chọn đồ uống </p>
    <div class="form-group col-12">
      <hr class="mt-5 mb-5" />
    </div>

    <div class="form-group">
      <label>Đồ uống:</label>
      <select id="select-drink" class="form-control">
        <option>Chọn đồ uống</option>
      </select>
    </div>
    <button id="show-result" onclick="onBtnHienThiClick()" class="btn btn-primary w-25">Hiển thị</button>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      "use strict";
      console.log("Load trang tại đây");
      loadDataToDrinkSelect();
    }
    function onBtnHienThiClick() {
      "use strict";
      console.log("Nút hiển thị dc ấn");
      var vFormObj = {
        drinkValue: "",
        drinkText: ""
      };
      getDrinkData(vFormObj);
      showDrinkObjToConsole(vFormObj);
    }
    function loadDataToDrinkSelect() {
      "use strict";
      console.log("Function loadDataToDrinkSelect");
      var vXhttp = new XMLHttpRequest();
      callAPIGetDrinkData(vXhttp);
      vXhttp.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
          handleLoadDataToSelectDrink(vXhttp);
        }
      };
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function callAPIGetDrinkData(paramXhttp) {
      paramXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      paramXhttp.send();
    }
    function handleLoadDataToSelectDrink(paramXhttp) {
      "use strict";
      console.log(paramXhttp.responseText);
      var vArrayDrinkList = JSON.parse(paramXhttp.responseText);

      var vElementSelectDrink = document.getElementById("select-drink");
      for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
        var vDrinkOptionElement = document.createElement("option");
        vDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
        vDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
        vElementSelectDrink.appendChild(vDrinkOptionElement);
      }
    }
    //mã nguồn để load data về
    // function sampleCodeLoadData() {
    //   var xhttp = new XMLHttpRequest();
    //   xhttp.onreadystatechange =
    //     function () {
    //       if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
    //         console.log(xhttp.responseText); //ghi response text ra console.log
    //       }
    //     };
    //   xhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
    //   xhttp.send();
    // }
    function getDrinkData(paramDrinkObj) {
      var vDrinkSelect = document.getElementById("select-drink");
      paramDrinkObj.drinkValue = vDrinkSelect.value;
      paramDrinkObj.drinkText = vDrinkSelect.option[vDrinkSelect.selectedIndex].text;
    }
    function showDrinkObjToConsole(paramDrinkObj) {
      console.log(paramDrinkObj);
    }

  </script>
</body>

</html>